#include <bits/stdc++.h>
using namespace std;

const int MAXN = 1e5 + 10;
int arr[MAXN];
int oper[MAXN + 1];

int tree[MAXN * 4];
int LEFT[MAXN], RIGHT[MAXN];
void build(int v, int l, int r) {
	tree[v] = 0;
	if (l < r) {
		int m = (l + r) / 2;
		build(v * 2, l, m);
		build(v * 2 + 1, m + 1, r);
	}
}

int get(int v, int cl, int cr, int l, int r) {
	if (cr < l || r < cl || l > r) return 0;
	if (l <= cl && cr <= r) return tree[v];
	int cm = (cl + cr) / 2;
	return max(get(v * 2, cl, cm, l, r), get(v * 2 + 1, cm + 1, cr, l, r));
}

void update(int v, int l, int r, int pos, int val) {
	if (l == r) {
		tree[v] = max(tree[v], val);
	} else {
		int m = (l + r) / 2;
		if (pos <= m)
			update(v * 2, l, m, pos, val);
		else
			update(v * 2 + 1, m + 1, r, pos, val);
		tree[v] = max(tree[v * 2], tree[v * 2 + 1]);
	}
}

signed main() {
	ios_base::sync_with_stdio(false);

	int n, m;
	cin >> n >> m;
	for (int i = 0; i < n; i++) {
		int l, r;
		cin >> l >> r;
		oper[l - 1]++;
		oper[r]--;
	}
	int bal = 0;
	for (int i = 0; i < m; i++) {
		bal += oper[i];
		arr[i] = bal;
	}
	// for (int i = 0; i < m; i++) cout << arr[i] << " ";

	// cout << endl;

	build(1, 0, n);
	for (int i = 0; i < m; i++) {
		int val = get(1, 0, n, 0, arr[i]) + 1;
		LEFT[i] = val;
		update(1, 0, n, arr[i], val);
	}
	build(1, 0, n);
	for (int i = m - 1; i >= 0; i--) {
		int val = get(1, 0, m, 0, arr[i]) + 1;
		RIGHT[i] = val;
		update(1, 0, n, arr[i], val);
	}
	int ans = 0;
	for (int i = 0; i < m; i++)
		ans = max(ans, LEFT[i] + RIGHT[i] - 1);
	cout << ans << endl;

	return 0;
}