#include <unordered_map>
#include <algorithm>
#include <iostream>
#include <iomanip>
#include <string>
#include <vector>
#include <ctime>
#include <cmath>
#include <set>
#include <map>

using namespace std;

#define forn(n) for(int i = 0; i < (n); ++i)
#define fornm(n, m) for(int i = 0; i < (n); ++i) for(int j = 0; j < (m); ++j)

typedef long long ll;
typedef long double ld;
typedef vector<int> vint;
typedef vector<vector<int> > vvint;
typedef vector<ll> vll;
typedef vector<vector<ll> > vvll;

const int MSIZE = 1e5;
const double EPS = 1e-9;
const double PI = acos(-1);
const ll INF = 1e18;

void solve(){
    string s;
    cin >> s;
    map<pair<pair<char, char>, int>, int> mp;
    
    for (int i = 0; i < s.length(); ++i)
        for (int j = 0; j < s.length(); ++j){
            if (i != j){
                int dist = (j - i + s.length()) % s.length();
                mp[{{s[i], s[j]}, dist}]++;
            }
        }
        
    ll allwin = 0, allgame = 0;
    for (char c = 'a'; c <= 'z'; ++c){
        ll bestwin = 0, bestall = 0;
        for (int dist = 1; dist < s.length(); ++dist){
            ll win = 0, all = 0;
            for (char d = 'a'; d <= 'z'; ++d){
                int k = mp[{{c, d}, dist}];
                if (k == 1)
                    win += k;
                all += k;
            }
            if (bestall == 0)
                bestwin = win, bestall = all;
            else if (bestwin * all < bestall * win) {
                bestwin = win;
                bestall = all;
            }
        }
        allwin += bestwin;
        allgame += bestall;
    }
    double res = (double) allwin / allgame;
    cout << fixed << setprecision(9) << res;
}


int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
#ifndef ONLINE_JUDGE
    freopen("input.in", "r", stdin);
    //freopen("output.out", "w", stdout);
#endif
    solve();
#ifndef ONLINE_JUDGE
    //cerr << fixed << setprecision(6) << (ld)clock() / CLOCKS_PER_SEC << '\n';
#endif
    return 0;
}

