#include <unordered_map>
#include <algorithm>
#include <iostream>
#include <iomanip>
#include <string>
#include <vector>
#include <ctime>
#include <cmath>
#include <set>
#include <map>

using namespace std;

#define forn(n) for(int i = 0; i < (n); ++i)
#define fornm(n, m) for(int i = 0; i < (n); ++i) for(int j = 0; j < (m); ++j)

typedef long long ll;
typedef long double ld;
typedef vector<int> vint;
typedef vector<vector<int> > vvint;
typedef vector<ll> vll;
typedef vector<vector<ll> > vvll;

const int MSIZE = 1e5;
const double EPS = 1e-9;
const double PI = acos(-1);
const int INF = 1e9;

vector<int> great(vector<int>& v, int n){
    vector<int> dp;
    vector<int> res(v.size() + 1, INF);
    res[0] = v[0];
    vector<int> output(v.size());
    output[0] = 1;
    for (int i = 1; i < v.size(); ++i){
        int it = upper_bound(res.begin(), res.end(), v[i]) - res.begin();
        res[it] = v[i];
        output[i] = it + 1;
    }
    return output;
}

void solve(){
    int n, m;
    cin >> n >> m;
    vector<int> v(m + 1);
    for (int i = 0; i < n; ++i){
        int l, r;
        cin >> l >> r;
        l--;
        v[l]++;
        v[r]--;
    }
    int add = v[0];
    for (int i = 1; i < v.size(); ++i){
        add += v[i];
        v[i] = add;
    }
    v.pop_back();
    vector<int> v1 = great(v, n);
    reverse(v.begin(), v.end());
    vector<int> v2 = great(v, n);
    reverse(v2.begin(), v2.end());
    int res = 0;
    for (int i = 0; i < v1.size(); ++i)
        res = max(res, v1[i] + v2[i] - 1);
    cout << res;
}


int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
#ifndef ONLINE_JUDGE
    freopen("input.in", "r", stdin);
    //freopen("output.out", "w", stdout);
#endif
    solve();
#ifndef ONLINE_JUDGE
    //cerr << fixed << setprecision(6) << (ld)clock() / CLOCKS_PER_SEC << '\n';
#endif
    return 0;
}

