/*
    Program by T1rex a.k.a Hrumka.
    Olympiad: Technocup 2018 final.
    Date 04.03.2018.
    All copyrights reserved.
*/
#include <bits/stdc++.h>

#define pb push_back
#define mp make_pair
#define pp pop_back

#define F first
#define S second
#define FF F.F
#define FS F.S
#define SF S.F
#define SS S.S

#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()

using namespace std;

typedef long long ll;
typedef unsigned long long ull;
typedef long double ldb;

typedef pair < int, int > pii;
typedef pair < ll, ll > pll;
typedef pair < int, ll > pil;
typedef pair < ll, int > pli;

const int inf = 1e9;
const ll INF = 1e18;
const int mod = 1e9 + 7;
const int MAXN = (int)1e6 + 228;
const double eps = 1e-6;
const double pi = acos (-1.0);

int t1[4 * MAXN], t2[4 * MAXN];
int n, m;

int get1 (int l, int r, int v = 1, int tl = 1, int tr = n) {
    if (l <= tl && tr <= r) return t1[v];
    if (tl > r || tr < l) return 0;
    int tm = (tl + tr) >> 1;
    return max(get1 (l, r, (v << 1), tl, tm), get1 (l, r, (v << 1) | 1, tm + 1, tr));
}

int get2 (int l, int r, int v = 1, int tl = 1, int tr = n) {
    if (l <= tl && tr <= r) return t2[v];
    if (tl > r || tr < l) return 0;
    int tm = (tl + tr) >> 1;
    return max(get2 (l, r, (v << 1), tl, tm), get2 (l, r, (v << 1) | 1, tm + 1, tr));
}

void update1 (int pos, int val, int v = 1, int tl = 1, int tr = n) {
    if (tl == tr) {
        t1[v] = val;
        return;
    }
    int tm = (tl + tr) >> 1;
    if (pos <= tm)
        update1 (pos, val, (v << 1), tl, tm);
    else
        update1 (pos, val, (v << 1) | 1, tm + 1, tr);
    t1[v] = max(t1[(v << 1)], t1[(v << 1) | 1]);
}


void update2 (int pos, int val, int v = 1, int tl = 1, int tr = n) {
    if (tl == tr) {
        t2[v] = val;
        return;
    }
    int tm = (tl + tr) >> 1;
    if (pos <= tm)
        update2 (pos, val, (v << 1), tl, tm);
    else
        update2 (pos, val, (v << 1) | 1, tm + 1, tr);
    t2[v] = max(t2[(v << 1)], t2[(v << 1) | 1]);
}

int e[MAXN];
int d1[MAXN], d2[MAXN];
int result, tmp;
int pref[MAXN];

int main () {
    ios_base :: sync_with_stdio (false);
    cin.tie (NULL); cout.tie (NULL);
    cin >> n >> m;
    for (int i = 1; i <= n; ++i) {
        int l, r;
        cin >> l >> r;
        e[l]++; --e[1 + r];
    }
    for (int i = 1; i <= m; ++i) pref[i] = pref[i - 1] + e[i];
    //for (int i = 1; i <= m; ++i) cout << pref[i] << ' ';
    //cout << endl;
    for (int i = 1; i <= m; ++i) {d1[i] = get1 (1, 1 + pref[i]) + 1; update1 (1 + pref[i], d1[i]);}
    for (int i = m; i >= 1; --i) {d2[i] = get2 (1, 1 + pref[i]) + 1; update2 (1 + pref[i], d2[i]);}
   /* for (int i = 1; i <= m; ++i) cout << d1[i] << ' ';
    cout << endl;
    for (int i = m; i >= 1; --i) cout << d2[i] << ' ';
    cout << endl;            */
    for (int i = 1; i <= m; ++i) {
        result = max (result, tmp + d2[i]);
        tmp = max (tmp, d1[i]);
    }
    cout << max (result, tmp);
    //cerr << "Time elapsed: " << (clock () + 0.) / CLOCKS_PER_SEC;
    return 0;
}