#include <bits/stdc++.h>

typedef long long ll;

#define forn(i, n) for (int i = 0; i < n; ++i)
#define x first
#define y second
#define point pair<int, int>

using namespace std;

const int N = 1e5 + 3, BIG = 1e9 + 7, MOD = 1e9 + 7, P = 'z' - 'a' + 1, K = 3;

struct Node{
	int L, R, val;
	Node* left;
	Node* right;
	Node(int L1, int R1, int v) {
		val = v;
		left = nullptr;
		right = nullptr;
		L = L1;
		R = R1;
	}
};

Node* build(int L, int R) {
	Node* v = new Node(L, R, 0);
	if (L + 1 == R)
		return v;
	int mid = (L + R) / 2;
	v->left = build(L, mid);
	v->right = build(mid, R);
	return v;
}

int get_max(Node* v, int L, int R) {
	if (R <= v->L || v->R <= L)
		return 0;
	if (L <= v->L && v->R <= R)
		return v->val;
	return max(get_max(v->left, L, R), get_max(v->right, L, R));
} 

void update(Node* v, int L, int x) {
	if (v->R <= L || L + 1 <= v->L)
		return;
	if (v->L + 1 == v->R) {
		v->val = x;
		return;
	}
	update(v->left, L, x);
	update(v->right, L, x);
	v->val = max(v->left->val, v->right->val);
}


void out_tree(Node* v) {
	if (v->left) {
		cout << "(";
		out_tree(v->left);
		cout<< ")";
	}
	cout << v->val;
	if (v->right) {
		cout << "(";
		out_tree(v->right);
		cout<< ")";
	}
}


int main() {
	// freopen("a.in", "r", stdin), freopen("a.out", "w", stdout);
	ios_base:: sync_with_stdio(0), cin.tie(0), cout.tie(0);
	int n, m, fr, to;
	cin >> n >> m;
	vector<int> a(m + 1);

	forn(i, n) {
		cin >> fr >> to, --fr, --to;	
		++a[fr];
		--a[to + 1];
	}
	forn(i, m)
		if (i > 0)
			a[i] += a[i - 1];

	/*/
	forn(i, m)
		cout << a[i] << " ";
	cout << "\n";
	//*/

	Node* tree_L = build(0, m + 1);

	vector<int> max_L(m + 1), max_R(m + 1);
	for (int i = 0; i < m; ++i) {
		max_L[i] = max(1, get_max(tree_L, 0, a[i] + 1) + 1);
		update(tree_L, a[i], max_L[i]);
		// out_tree(tree_L);
		// cout << "\n";
	}

	Node* tree_R = build(0, m + 1);
	for (int i = m - 1; i >= 0; --i) {
		max_R[i] = max(1, get_max(tree_R, 0, a[i] + 1) + 1);
		update(tree_R, a[i], max_R[i]);
	}
	/*/
	forn(i, m)
		cout << max_L[i] << " ";
	cout << "\n";
	forn(i, m)
		cout << max_R[i] << " ";
	cout << "\n";
	//*/
	int ans = 0;
	forn(i, m)
		ans = max(ans, max_L[i] + (i + 1 < m ? max_R[i + 1] : 0));
	cout << ans;
	return 0;
}
