#include <bits/stdc++.h>

using namespace std;

struct Node{
    int val, l, r;
};

vector <Node> tree;

void build(int v, int l, int r) {
    tree[v].l = l;
    tree[v].r = r;
    tree[v].val = 0;
    if (r - l > 1) {
        build(2 * v, l, (l + r) / 2);
        build(2 * v + 1, (l + r) / 2, r);
    }
}

void change(int v, int k, int val) {
    if (tree[v].l > k || tree[v].r <= k) {
        return;
    }
    if (tree[v].r - tree[v].l == 1 && tree[v].l == k) {
        tree[v].val = val;
        return;
    }
    change(2 * v, k, val);
    change(2 * v + 1, k, val);
    tree[v].val = max(tree[2 * v].val, tree[2 * v + 1].val);
}

int get(int v, int l, int r) {
    if (tree[v].l >= r || tree[v].r <= l) return 0;
    if (tree[v].l >= l && tree[v].r <= r) return tree[v].val;
    return max(get(2 * v, l, r), get(2 * v + 1, l, r));
}

void renew(int v) {
    tree[v].val = 0;
    if (tree[v].r - tree[v].l != 1) {
        renew(2 * v);
        renew(2 * v + 1);
    }
}

int main()
{
    int n, m;
    cin >> n >> m;
    vector <int> a(m);
    vector <pair <int, int> > event;
    for (int i = 0; i < n; i++) {
        int x, y;
        cin >> x >> y;
        x--; y--;
        event.push_back({x, 0});
        event.push_back({y, 2});
    }
    for (int i = 0; i < m; i++) {
        event.push_back({i, 1});
    }
    sort(event.begin(), event.end());
    int cnt = 0;
    for (auto p : event) {
        if (p.second == 0) cnt++;
        if (p.second == 2) cnt--;
        if (p.second == 1) a[p.first] = cnt;
    }
    n++;
    int powern = 1;
    while (powern < n) {
        powern *= 2;
    }
    tree.resize(2 * powern);
    build(1, 0, powern);
    vector <int> dp1(m), dp2(m);
    for (int i = 0; i < m; i++) {
        dp1[i] = get(1, 0, a[i] + 1) + 1;
        change(1, a[i], dp1[i]);
    }
    renew(1);
    for (int i = m - 1; i >= 0; i--) {
        dp2[i] = get(1, 0, a[i] + 1) + 1;
        change(1, a[i], dp2[i]);
    }
    int ans = 0;
    for (int i = 0; i < m; i++) {
        ans = max(ans, dp1[i] + dp2[i] - 1);
    }
    cout << ans;
    return 0;
}
