#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;
typedef pair<ll, ll> par;
typedef vector<ll> vll;

#define X first
#define Y second
#define all(x) (x).begin(), (x).end()
#define pw(x) (1ll << (x))
#define sqr(x) ((x)*(x))

ll rnd() {
    ll res = rand();
    res = (res << 16) + rand();
    return res;
}

ll logn(ll n) {
    ll xx = ll(log2(ld(n)));
    if (pw(xx) != n) ++xx;
    return xx;
}

struct Sparse {
    vector<vll> t;

    void build(vll &a) {
        ll n = a.size();
        t.resize(logn(n) + 1);
        t[0] = a;
        for (int i = 1; i < t.size(); ++i) {
            t[i].resize(n - pw(i) + 1);
            for (int j = 0; j < t[i].size(); ++j) {
                t[i][j] = min(t[i - 1][j], t[i - 1][j + pw(i - 1)]);
            }
        }
    }

    ll Min(ll l, ll r) {
        if (l > r) swap(l, r);
        ll xx = logn(r - l + 1);
        ll f1 = t[xx][l], f2 = t[xx][r - pw(xx) + 1];
        return min(f1, f2);
    }

    void print() {
        for (int i = 0; i < t.size(); ++i) {
            for (int j = 0; j < t[i].size();++j) cout << t[i][j] << ' ';
            cout << '\n';
        }
    }
};

struct SGTree {
    ll size;
    vll t;
    void build(ll n) {
        size = pw(logn(n));
        t.assign(2 * size, 0);
    }

    void mod(ll i, ll x) {
        i += size;
        t[i] = x;
        i >>= 1;
        while (i) {
            t[i] = max(t[i * 2], t[i * 2 + 1]);
            i >>= 1;
        }
    }

    ll f(ll i, ll l, ll r, ll L, ll R) {
        if (L >= r || l >= R) return 0;
        if (l >= L && R >= r) return t[i];
        ll m = (l + r) /2;
        ll f1 = f(i * 2, l, m, L, R);
        ll f2 = f(i * 2 + 1, m, r, L, R);
        return max(f1, f2);
    }
};

int source() {
    ll n, m;
    cin >> n >> m;
    vll x(m, 0);
    vector<par> a;
    for (int i = 0; i < n; ++i) {
        ll l, r;
        cin >> l >> r;
        --l;
        a.push_back({l, 1});
        if (r != m) a.push_back({r, -1});
    }
    sort(all(a));
    ll it = 0, kol = 0;
    for (int i = 0; i < m; ++i) {
        while (it < a.size() && i == a[it].X) {
            kol += a[it].Y;
            it++;
        }
        x[i] = kol;
    }
    vll dp1(m, 0), dp2(m, 0);
    SGTree t1, t2;
    t1.build(n), t2.build(n);
    for (int i = 0; i < m; ++i) {
        dp1[i] = t1.f(1, 0, t1.size, 0, x[i] + 1);
        t1.mod(x[i], dp1[i] + 1);
    }
    for (int i = m - 1; i >= 0; --i) {
        dp2[i] = t2.f(1, 0, t2.size, 0, x[i] + 1);
        t2.mod(x[i], dp2[i] + 1);
    }
    ll ans = 0;
    for (int i = 0; i <m; ++i) ans = max(ans, dp1[i] + dp2[i] + 1);
    cout << ans;
    return 0;
}

int main() {
#ifdef aokigahara
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif // aokigahara

    ios::sync_with_stdio(0);
    cin.tie(0), cout.tie(0);

    source();
#ifdef aokigahara
    cerr << "\n\nTIME : " << fixed << setprecision(12) << clock() * 1.0 / CLOCKS_PER_SEC << "\n";
#endif // aokigahara
    return 0;
}
