#include <iostream>
#include <algorithm>
#include <cstdio>
#include <vector>
#include <cassert>

using namespace std;

struct Seg_Tree {

    int n;
    vector <int> d;

    Seg_Tree(int n = 0): n(n) { d.resize(4 * n); }

    void update(int i, int l, int r, int pos, int val) {
        if (l == r) {
            d[i] = max(d[i], val);
            return;
        }
        int m = (l + r) / 2;
        if (pos <= m)
            update(2 * i, l, m, pos, val);
        else
            update(2 * i + 1, m + 1, r, pos, val);
        d[i] = max(d[2 * i], d[2 * i + 1]);
    }
    void update(int pos, int val) { update(1, 0, n - 1, pos, val); }

    int get(int i, int l, int r, int ql, int qr) {
        if (l > qr || ql > r)
            return 0;
        if (ql <= l && r <= qr)
            return d[i];
        int m = (l + r) / 2;
        return max(get(2 * i, l, m, ql, qr), get(2 * i + 1, m + 1, r, ql, qr));
    }
    int get(int ql, int qr) { return get(1, 0, n - 1, ql, qr); }

} tr;

vector <int> s;
vector <int> dp_pref, dp_suf, pref_max;

int32_t main() {
    //assert(freopen("input.txt", "r", stdin));
    //assert(freopen("output.txt", "w", stdout));

    ios_base::sync_with_stdio(false);

    int n, m; cin >> n >> m;
    s.resize(m);
    for (int i = 0; i < n; i++) {
        int l, r; cin >> l >> r;
        l--, r--;
        s[l]++;
        if (r + 1 < m)
            s[r + 1]--;
    }

    for (int i = 1; i < (int)s.size(); i++)
        s[i] += s[i - 1];

    tr = Seg_Tree(n + 1);
    dp_pref.resize((int)s.size());
    pref_max.push_back(0);
    for (int i = 0; i < (int)s.size(); i++) {
        dp_pref[i] = tr.get(0, s[i]) + 1;
        tr.update(s[i], dp_pref[i]);

        pref_max.push_back(max(pref_max.back(), dp_pref[i]));
    }

    int ans = 0;

    tr = Seg_Tree(n + 1);
    dp_suf.resize((int)s.size());
    for (int i = (int)s.size() - 1; i >= 0; i--) {
        dp_suf[i] = tr.get(0, s[i]) + 1;
        tr.update(s[i], dp_suf[i]);

        int cur = dp_suf[i] + pref_max[i];
        if (cur > ans)
            ans = cur;
    }

    cout << ans << endl;

    return 0;
}
