#include <bits/stdc++.h>
using namespace std;

const int MAXN = 100001;

inline int get(int l, int r, int s) {
    r--;
    if ((l & 1) != s) {
        l++;
    }
    if ((r & 1) != s) {
        r--;
    }
    if (r < l) return 0;
    return (r - l) / 2 + 1;
}

long long solve(vector<pair<int, int>> &a, int s) {
    sort(a.begin(), a.end());
    int fr = 0;
    int ll = -1;
    set<pair<int, int>> left, right;
    for (int i = 0; i < a.size(); i++) {
        right.insert({a[i].second, i});
    }

    vector<int> mxy(2 * MAXN + 1, -2 * MAXN), mny(2 * MAXN + 1, 2 * MAXN);
    for (auto p : a) {
        mxy[p.first + MAXN] = max(mxy[p.first + MAXN], p.second);
        mny[p.first + MAXN] = min(mny[p.first + MAXN], p.second);
    }

    long long ans = 0;

    for (int x = -MAXN; x <= MAXN; x++) {
        int cc = (x + s) % 2;
        if (cc < 0) cc += 2;
        cc = 1 - cc;
        
        while (ll + 1 < a.size() && a[ll + 1].first < x) {
            ll++;
            left.insert({a[ll].second, ll});
        }
        while (fr < a.size() && a[fr].first <= x) {
            right.erase({a[fr].second, fr});
            fr++;
        }

        if (left.empty() || right.empty()) {
            continue;
        }

        vector<pair<int, int>> segs;

        // none from left, none from right
        int cmny = mny[x + MAXN];
        int cmxy = mxy[x + MAXN];
        segs.push_back({cmny, cmxy});

        // one from left, none from right
        if (left.size() >= 2) {
            // down from left
            cmny = min(mny[x + MAXN], left.begin()->first);
            cmxy = mxy[x + MAXN];
            segs.push_back({cmny, cmxy});

            // up from left
            cmny = mny[x + MAXN];
            cmxy = max(mxy[x + MAXN], left.rbegin()->first);
            segs.push_back({cmny, cmxy});
        }

        // one from right, none from left
        if (right.size() >= 2) {
            // down from right
            cmny = min(mny[x + MAXN], right.begin()->first);
            cmxy = mxy[x + MAXN];
            segs.push_back({cmny, cmxy});

            // up from right
            cmny = mny[x + MAXN];
            cmxy = max(mxy[x + MAXN], right.rbegin()->first);
            segs.push_back({cmny, cmxy});
        }
        
        // two from left, none from right
        if (left.size() >= 3) {
            cmny = min(mny[x + MAXN], left.begin()->first);
            cmxy = max(mxy[x + MAXN], left.rbegin()->first);
            segs.push_back({cmny, cmxy});
        }
        
        // two from right, none from left
        if (right.size() >= 3) {
            cmny = min(mny[x + MAXN], right.begin()->first);
            cmxy = max(mxy[x + MAXN], right.rbegin()->first);
            segs.push_back({cmny, cmxy});
        }
        
        // one from right, one from left
        if (left.size() >= 2 && right.size() >= 2) {
            // down from left, up from right
            cmny = min(mny[x + MAXN], left.begin()->first);
            cmxy = max(mxy[x + MAXN], right.rbegin()->first);
            segs.push_back({cmny, cmxy});
            
            // down from right, up from left
            cmny = min(mny[x + MAXN], right.begin()->first);
            cmxy = max(mxy[x + MAXN], left.rbegin()->first);
            segs.push_back({cmny, cmxy});
        }

        vector<pair<int, int>> evs;
        for (auto p : segs) {
            if (p.first < p.second) {
                evs.push_back({p.first + 1, -1});
                evs.push_back({p.second, 1});
            }
        }
        sort(evs.begin(), evs.end());
        int b = 0;
        for (int i = 0; i < evs.size(); i++) {
            if (b > 0) {
                ans += get(evs[i - 1].first, evs[i].first, cc);
            }
            b -= evs[i].second;
        }
    }
    
    return ans;
}

int main() {
#ifdef DEBUG
    freopen("input", "r", stdin);
#endif
    ios::sync_with_stdio(0);
    cin.tie(0);

    int n;
    cin >> n;
    vector<pair<int, int>> e, o;
    for (int i = 0; i < n; i++) {
        int x, y;
        cin >> x >> y;
        if ((x + y) % 2 == 0) {
            e.push_back({x, y});
        } else {
            o.push_back({x, y});
        }
    }

    long long ans = solve(e, 0) + solve(o, 1);

    cout << ans << endl;

    return 0;
}
