#include <bits/stdc++.h>
#define int long long
#define ll long long
#define null null

using namespace std;

const int mx = 2e5;

struct st {
	vector<pair<int, int> > t;
	vector<int> mod;
	int n;
	st() {}
	pair<int, int> merge(pair<int, int> a, pair<int, int> b) {
		if (a.first == b.fisrt)
			return {a.first, a.second + b.second};
		else
			return max(a, b);
	}
	void build(int v, int tl, int tr) {
		if (tl == tr)
			t[v] = {0, 1};
		else {
			int tm = (tl + tr) / 2;
			build(v * 2, tl, tm);
			build(v * 2 + 1, tm + 1, tr);
			t[v] = merge(t[v * 2], t[v * 2 + 1]);
		}
	}
	void init(int _n) {
		n = _n;
		t.resize(4 * n);
		mod.resize(4 * n);
		build(1, 0, n - 1);
	}
	void update(int l, int r, int val, int v, int tl, int tr) {
		if (l > r)
			return;
		if (l == tl && r == tr)
			mod[v] += val;
		else {
			int tm = (tl + tr) / 2;
			update(l, min(r, tm), val, v * 2, tl, tm);
			update(max(l, tm + 1), r, val, v * 2 + 1, tm + 1, tr);
			t[v] = merge({t[v * 2].first + mod[v * 2], t[v * 2].second}, {t[v * 2 + 1].first + mod[v * 2 + 1], t[v * 2 + 1].second});
		}
	}
	int get() {
		if (t[1].first + mod[1] == 4)
			return t[1].second;
		else
			return 0;
	}
	void update(int l, int r, int val) {
		update(l, r, val, 1, 0, n - 1);
	}
};

struct rectangle {
	int x1, y1, x2, y2;
};

struct event {
	int x, y1, y2, up;
};

bool operator < (e a, e b) {
	return a.x < b.x;
}

int relax(int x) {
	if (x < -2 * mx)
		x = -2 * mx;
	if (x > 2 * mx)
		x = 2 * mx;
	x += 2 * mx;
	return x;
}

int intersect(vector<rectangle> a) {
	int n = a.size(), ans = 0;
	vector<event> e;
	for (int i = 0; i < n; ++i) {
		relax(a[i].x1);
		relax(a[i].x2);
		relax(a[i].y1);
		relax(a[i].y2);
		e.push_back({a[i].x1, a[i].y1, a[i].y2, 1});
		e.push_back({a[i].x2 + 1, a[i].y1, a[i].y2, -1});
	}
	sort(e.begin(), e.end());
	st t;
	t.init(4 * mx + 1);
	int ptr = 0;
	for (int i = 0; i <= 4 * mx; ++i) {
		while (ptr < e.size() && e[i].x == i) {
			t.update(e[i].y1, e[i].y2, e[i].up);
		}
		ans += t.get();
	}
	return ans;
}

struct point {
	int x, y;
	point() {}
}

point change_coords(point a) {
	point res;
	res.x = (a.x + a.y) / 2;
	res.y = (a.x - a.y) / 2;
	return res;
}

const ll INF = 1e18;

void add_rectangle(point p1, point p2, vector<rectangle> &v) {
	rectangle cur;
	cur.x1 = p1.x;
	cur.x2 = p2.x;
	cur.y1 = p1.y;
	cur.y2 = p2.y;
	return cur;
}

void push(vector<point> p, int dx, int dy) {
	//!HARD
}

ll cnt(vector<pair<int, int> > a) {
	if (a.size() < 4)
		return 0;
	vector<rectangle> v;
	int M_x = -INF, m_x = INF, M_y = -INF, m_y = INF;
	for (int i = 0; i < n; ++i) {
		M_x = max(M_x, a[i].x);
		m_x = min(m_x, a[i].x);
		M_y = max(M_y, a[i].y);
		m_y = min(m_y, a[i].y);
	}
	vector<int> Mxv, txv, Myv, tyv;
	for (int i = 0; i < n; ++i) {
		if (a[i].x == m_x)
			txv.push_back(a[i].y);
		if (a[i].y == m_y)
			tyv.push_back(a[i].x);
		if (a[i].x == M_x)
			Mxv.push_back(a[i].y);
		if (a[i].y == M_y)
			Myv.push_back(a[i].x);
	}
	vector<point> P;
	for (auto y : Mxv) {
		P.push_back(change_coords({M_x, y}));
	}
	push(P, -1, 0);
	for (auto t : txv) {
		P.push_back(change_coords({m_x, t}));
	}
	push(P, 1, 0);
	for (auto t : Myv) {
		P.push_back(change_coords({t, M_y}));
	}
	push(P, 0, 1);
	for (auto t : tyv) {
		P.push_back(change_coords({t, m_y}));
	}
	push(P, 0, -1);
	ll res = intersect(v);
	return res;
}

int n;
vector<point> a;

signed main() {
	cin >> n;
	a.resize(n);
	ll ans = 0;
	vector<point> a1, a2;
	for (int i = 0; i < n; ++i) {
		cin >> a[i].x >> a[i].y;
		if ((a[i].x + a[i].y) % 2 == 0) {
			a[i].x--;
			a1.push_back(a[i]);
		}
		else {
			a2.push_back(a[i]);
		}
	}
	ll ans = cnt(a1) + cnt(a2);
	cout << ans << endl;
}